// $Id: Clone.cc 69 2006-02-11 00:44:22Z jari $

#include "Clone.h"

#include <fstream>
#include <iostream>

#include <basefile.h>


namespace theplu {
namespace wenni {


	Clone::Clone(BASE::BaseFileSection& bfs, const std::string& colname, 
							 const std::string& output_file)
		: column_name_(colname), output_file_(output_file)
	{
		BASE::FieldList columns, assayFields, assays;
		std::string assay_names;
		if( !bfs.findFieldList("columns", columns) ||
				!bfs.findFieldList("assayFields", assayFields) ||
				!bfs.findFieldList("assays", assays) ||
				!bfs.findStringOpt("assays", assay_names)) {
			std::cerr << "Missing header columns/assayFields/assays\n";
			exit(-1);
		}
		if (!bfs.findFieldPos(column_name_,column_number_,columns)) {
			std::cerr << "Cannot find column " << column_name_ << std::endl;
			exit(-1);
		}
		total_nof_columns_= columns.size()-1 + assayFields.size()*assays.size();
	}



	void Clone::write(void)
	{
		std::filebuf fb;
		fb.open (output_file_.c_str(),std::ios::out);
		std::ostream s(&fb);
		for (size_t i=0; i<clone_.size(); i++) 
			s << clone_[i] << "\n";
		fb.close();
	}


}} // of namespace wenni and namespace theplu
