// $Id: Parameter.h 69 2006-02-11 00:44:22Z jari $

#ifndef _theplu_wenni_nnifileconverter_parameter_
#define _theplu_wenni_nnifileconverter_parameter_

#include <string>

namespace theplu {
namespace wenni {
namespace nnifileconverter {

  // class for command line options.
	class Parameter {
	public:
		Parameter(const Parameter&);	// not implemented
		Parameter(const int argc,const char *argv[]);

		inline const double beta(void) const { return beta_; }
		inline const std::string& bg2(void) const { return bg2_; }
		inline const std::string& bg1(void) const { return bg1_; }
		inline const std::string& bgstd1(void) const { return bgstd1_; }
		inline const std::string& bgstd2(void) const { return bgstd2_; }
		inline const std::string& datatype(void) const { return datatype_; }
		inline const std::string& fg1(void) const { return fg1_; }
		inline const std::string& fg2(void) const { return fg2_; }
		inline const std::string& logratio(void) const { return logratio_; }
		inline const std::string& weight(void) const { return weight_; }

	private:
		void analyse(void);
		void defaults(void);
		void help(void) const;

		double beta_;
		std::string bg1_;
		std::string bg2_;
		std::string bgstd1_;
		std::string bgstd2_;
		std::string datatype_;
		std::string fg1_;
		std::string fg2_;
		std::string logratio_;
		std::string weight_;
	};

}}} // of namespace nnifileconverter, wenni and namespace theplu

#endif
