// $Id: Parameter.h 69 2006-02-11 00:44:22Z jari $

#ifndef _theplu_wenni_nni_parameter_
#define _theplu_wenni_nni_parameter_

#include <string>

#include "nni.h"

namespace theplu {
namespace wenni {

  // class for command line options.
	class Parameter {

	public:
		Parameter(const Parameter&);	// not implemented
		Parameter(const int argc,const char *argv[]);

		inline double beta(void) const { return beta_; }
		inline const std::string& data_file(void) const { return data_file_; }
		inline int neighbours(void) const { return neighbours_; }
		inline NNIalgorithm nni_algorithm(void) const { return nni_algorithm_; }
		inline double weight_cutoff(void) const { return weight_cutoff_; }
		inline const std::string& weight_file(void) const { return weight_file_; }
		inline bool weight_is_snr(void) const { return weight_is_snr_; }

	private:
		void analyse(void);
		void defaults(void);

		double beta_;
		std::string data_file_;
		int neighbours_;
		NNIalgorithm nni_algorithm_;
		double weight_cutoff_;
		std::string weight_file_;
		bool weight_is_snr_;
	};

}} // of namespace wenni and namespace theplu

#endif
