// $Id: FileIO.cc 69 2006-02-11 00:44:22Z jari $

#include <c++_tools/utility/FileIO.h>

#include <iostream>
#include <unistd.h>


namespace theplu {
namespace utility {

	int FileIO::access_rights(const std::string& path,
														const std::string& bits) const {
		if (int value=access(path.c_str(),F_OK)) {
			std::cerr << "access_rights: File '" << path << "' does not exist."
								<< std::endl;
			return value;
		}
		int mode=0;
		for (u_int i=0; i<bits.length(); i++)
			switch (bits[i]) {
					case 'r':
						mode|=R_OK;
						break;
					case 'w':
						mode|=W_OK;
						break;
					case 'x':
						mode|=X_OK;
						break;
			}
		return access(path.c_str(),mode);
	}

}} // of namespace utility and namespace theplu
