// $Id: Parameter.h 69 2006-02-11 00:44:22Z jari $

#ifndef _theplu_wenni_basefileconverter_parameter_
#define _theplu_wenni_basefileconverter_parameter_

#include <string>
#include <vector>

namespace theplu {
namespace wenni {

  // class for command line options.
	class Parameter {
	public:
		Parameter(const Parameter&);	// not implemented
		Parameter(const int argc,const char *argv[]);

		inline const std::string& input_file(void) const { return input_file_; }
		inline int nof_property(void) const { return property_.size(); }
		inline const std::string& output_file(const int i) const
			{ return output_file_[i]; }
		inline const std::string& property(const int i) const
			{ return property_[i]; }
		inline bool show(void) const { return show_; }
		inline const std::string& type(const int i) const { return type_[i]; }

	private:
		void analyse(void);
		void help(void) const;

		std::string input_file_;		
		std::vector<std::string> output_file_;
		std::vector<std::string> property_;
		bool show_;
		std::vector<std::string> type_;
	};

}} // of namespace wenni and namespace theplu

#endif
