// $Id: NNIFileConverter.cc 69 2006-02-11 00:44:22Z jari $

#include "Parameter.h"
#include "weight.h"

#include <cmath>
#include <fstream>

#include <c++_tools/gslapi/matrix.h>


int main(const int argc,const char* argv[]) 
{
	theplu::wenni::nnifileconverter::Parameter option(argc,argv);
	std::ifstream is(option.fg1().c_str());
	theplu::gslapi::matrix fg1(is);
	is.close();
	is.open(option.bgstd1().c_str());
	theplu::gslapi::matrix bgstd1(is);
	is.close();
	is.open(option.fg2().c_str());
	theplu::gslapi::matrix fg2(is);
	is.close();
	is.open(option.bgstd2().c_str());
	theplu::gslapi::matrix bgstd2(is);
	is.close();

	theplu::gslapi::matrix bg1;
	theplu::gslapi::matrix bg2;
	if (option.datatype()==std::string("raw")) {
		is.open(option.bg1().c_str());
		bg1=theplu::gslapi::matrix(is);
		is.close();
		is.open(option.bg2().c_str());
		bg2=theplu::gslapi::matrix(is);
		is.close();
	}
	else
		bg1=bg2=theplu::gslapi::matrix(fg1.rows(),fg1.columns(),0.0);

	// Calculating log2ratio
	theplu::gslapi::matrix log2ratio(fg1.rows(),fg1.columns(),0.0);
	double log2=log(2);
	for (size_t i=0; i<log2ratio.rows(); i++) 
		for (size_t j=0; j<log2ratio.columns(); j++)
			if (fg1(i,j)>bg1(i,j) && fg2(i,j)>bg2(i,j))
				log2ratio(i,j)=log( (fg1(i,j)-bg1(i,j)) / (fg2(i,j)-bg2(i,j)) ) / log2;

	// calculating weights
	theplu::gslapi::matrix weight(fg1.rows(),fg1.columns());
	for (size_t i=0; i<weight.rows(); i++)
		for (size_t j=0; j<weight.columns(); j++) {
			using namespace theplu::wenni::weight;
			weight(i,j)=weight_SNR2(get_snr(fg1(i,j),bg1(i,j),bgstd1(i,j)),
															get_snr(fg2(i,j),bg2(i,j),bgstd2(i,j)),
															option.beta());
		}

	std::ofstream os(option.logratio().c_str());
	os << log2ratio;
	os.close();
	os.open(option.weight().c_str());
	os << weight;
	os.close();

	return 0;
}
